﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;

	public class Fibonacci extends Sprite
	{
		private var max:Number;
		private var fibonacci:Number;
		private var accident:Number;
		private var rapport:Number;
		private var rad:Number;
		private var growth:Number;
		private var sc_x:Number;
		private var sc_y:Number;
		private var rpx:Number;
		private var rpy:Number;
		
		private var cur:Number;
		private var rot:Number;
		public function Fibonacci()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
			setup();
		}
		private function setup():void
		{
			max			= 580;
			fibonacci	= 20/5.5;
			accident	= 0;
			rapport 	= 2
			rad 		= 30;
			growth		= 1.000;
			sc_x		= 120;
			sc_y		= 120;
			rpx			= 2;
			rpy			= 2;
		
			cur			= max;
			rot			= 0;
		}
		
		private function addedHandler(e:Event):void
		{
			addEventListener(Event.ENTER_FRAME, enterhandler);
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.CLICK, clickHandler);
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			graphics.clear();
			setup();
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			graphics.clear();
			setup();
			addEventListener(Event.ENTER_FRAME, enterhandler);
		}
		
		
		private function enterhandler(e:Event):void
		{
				cur--;
				
				sc_x*=rpx;
				sc_y*=rpy;
				rot += rapport;
				rot-= new int(rot/360)*270;
				rad*=growth;
				var x:Number = mouseX+Math.cos(rot * Math.PI/2) *rad;
				var y:Number = mouseY+Math.sin(rot * Math.PI/2) *rad;
				if(cur!= (max-1)){
					graphics.lineStyle(10,0xffffff,.05);
					graphics.lineTo(x,y);
				}else{
					graphics.moveTo(x,y);
				}
			}
		}
	}
